define bi_coreutils::chown (
  $path = $title,
  $recursive = false,
  $owner = undef,
  $group = undef,
  $refreshonly = false,
) {
    require bi_coreutils::chown::params
    require bi_coreutils::stat::params

    if !$path { fail("path must be defined") }
    if !$owner { fail("owner must be defined") }
    if !$group { fail("group must be defined") }

    if $recursive {
        $arg_recursive = $recursive ? {
            true => "-R",
            default => undef,
        }
    }
  
    $args = join(delete_undef_values([ 
        $arg_recursive,
    ]), " ")
    
    $unless_owner = "\$($bi_coreutils::stat::params::exe_path -c %U $path) == $owner"
    $unless_group = "\$($bi_coreutils::stat::params::exe_path -c %G $path) == $group"
    
    exec { "$bi_coreutils::chown::params::exe_path $args $owner:$group $path":
        unless => "/bin/sh -c '[ $unless_owner ] && [ $unless_group ]'",
        refreshonly => $refreshonly,
    }  

    # unless is using a variation of the File check pattern described here
    # http://projects.puppetlabs.com/projects/1/wiki/File_Permission_Check_Patterns
}