define bi_coreutils::cp (
  $source = $title,
  $dest = undef,
  $archive = undef,
  $backup = undef,
  $copy_contents = undef,
  $force = undef,
  $link = undef,
  $dereference = undef,
  $preserve = undef,
  $parents = undef,
  $recursive = undef,
  $remove_distination = undef,
  $sparse = undef,
  $strip_trailing_slashes = undef,
  $symbolic_link = undef,
  $suffix = undef,
  $target_directory = undef,
  $update = undef,
  $verbose = undef,
  $one_file_system = undef,
  $context = undef,
  $refreshonly = false,
) {
    require bi_coreutils::cp::params
  
    if !$source { fail("source must be defined") }
    if !$dest { fail("dest must be defined") }
    
    if $archive and is_bool($archive) {
        $arg_archive = $archive ? {
            true => "--archive",
            default => undef,
        }
    }
    
    if $backup and is_bool($backup) {
        $arg_backup = $backup ? {
            true => "--backup",
            default => undef,
        }
    }
    
    if $copy_contents and is_bool($copy_contents) {
        $arg_copy_contents = $copy_contents ? {
            true => "--copy-contents",
            default => undef,
        }
    }
    
    if $force and is_bool($force) {
        $arg_force = $force ? {
            true => "--force",
            default => undef,
        }
    }
    
    if $link and is_bool($link) {
        $arg_link = $link ? {
            true => "--link",
            default => undef,
        }
    }
    
    if $dereference and is_bool($dereference) {
        $arg_dereference = $dereference ? {
            true => "--dereference",
            default => undef,
        }
    }
    
    if $parents and is_bool($parents) {
        $arg_parents = $parents ? {
            true => "--parents",
            default => undef,
        }
    }
    
    if $preserve and is_bool($preserve) {
        $arg_preserve = $preserve ? {
            true => "--preserve",
            default => undef,
        }
    }
    
    if $parents and is_bool($parents) {
        $arg_parents = $parents ? {
            true => "--parents",
            default => undef,
        }
    }
    
    if $recursive and is_bool($recursive) {
        $arg_recursive = $recursive ? {
            true => "--recursive",
            default => undef,
        }
    }
    
    if $remove_distination and is_bool($remove_distination) {
        $arg_remove_distination = $remove_distination ? {
            true => "--remove-destination",
            default => undef,
        }
    }
    
    if $strip_trailing_slashes and is_bool($strip_trailing_slashes) {
        $arg_strip_trailing_slashes = $strip_trailing_slashes ? {
            true => "--strip-trailing-slashes",
            default => undef,
        }
    }
    
    if $sparse {
        $arg_sparse = is_string($sparse) ? {
            true => "--sparse=$sparse",
            default => undef,
        }
    }
    
    if $strip_trailing_slashes and is_bool($strip_trailing_slashes) {
        $arg_strip_trailing_slashes = $strip_trailing_slashes ? {
            true => "--strip-trailing-slashes",
            default => undef,
        }
    }
    
    if $symbolic_link and is_bool($symbolic_link) {
        $arg_symbolic_link = $symbolic_link ? {
            true => "--symbolic-link",
            default => undef,
        }
    }
    
    if $suffix {
        $arg_suffix = is_string($suffix) ? {
            true => "--suffix=$suffix",
            default => undef,
        }
    }
    
    if $target_directory {
        $arg_target_directory = is_string($target_directory) ? {
            true => "--target-directory=$target_directory",
            default => undef,
        }
    }
    
    if $update and is_bool($update) {
        $arg_update = $update ? {
            true => "--update",
            default => undef,
        }
    }
    
    if $verbose and is_bool($verbose) {
        $arg_verbose = $verbose ? {
            true => "--verbose",
            default => undef,
        }
    }
    
    if $one_file_system and is_bool($one_file_system) {
        $arg_one_file_system = $one_file_system ? {
            true => "--one-file-system",
            default => undef,
        }
    }
    
    if $context {
        $arg_context = is_string($context) ? {
            true => "--context=$context",
            default => undef,
        }
    }
    
    $args = join(delete_undef_values([ 
        $arg_archive,
        $arg_backup,
        $arg_copy_contents,
        $arg_force,
        $arg_link,
        $arg_dereference,
        $arg_preserve,
        $arg_parents,
        $arg_recursive,
        $arg_remove_distination,
        $arg_sparse,
        $arg_strip_trailing_slashes,
        $arg_symbolic_link,
        $arg_suffix,
        $arg_target_directory,
        $arg_update,
        $arg_verbose,
        $arg_one_file_system,
        $arg_context,
    ]), " ")
      
    exec { "$bi_coreutils::cp::params::exe_path $args \"$source\" \"$dest\"":
        creates => $dest,
        refreshonly => $refreshonly,
    }
}