define bi_coreutils::md5sum (
  $filename = $title,
  $check = false,
  $text = false,
  $binary = false,
  $warn = false,
  $status = false,
  $timeout = 5,
  $refreshonly = false,
) {
    require bi_coreutils::md5sum::params
    
    if !$filename { fail("filename is required") }
    if !$check { fail("check is required") }
    if !$text { fail("text is required") }
    if !$binary { fail("binary is required") }
    if !$warn { fail("warn is required") }
    if !$status { fail("status is required") }
    if !$timeout { fail("timeout is required") }
 
    $arg_check = $check ? {
        true => "--check",
        default => undef,
    }
    
    $arg_text = $text ? {
        true => "--text",
        default => undef,
    }
    
    $arg_binary = $binary ? {
        true => "--binary",
        default => undef,
    }
    
    $arg_warn = $warn ? {
        true => "--warn",
        default => undef,
    }
   
    $arg_status = $status ? {
        true => "--status",
        default => undef,
    }
    
    $args = join(delete_undef_values([ 
        $arg_check, 
        $arg_text,
        $arg_binary,
        $arg_warn,
        $arg_warn,
    ]), " ")
    
    exec { "$bi_coreutils::md5sum::params::exe_path $args $filename":
        timeout => $timeout,
        refreshonly => $refreshonly,
    }
}