define bi_coreutils::mkdir (
      $directory = $title,
      $mode = undef,
      $parents = true,
      $verbose = false,
      $timeout = 5,
) {
    require bi_coreutils::mkdir::params
  
    if $directory == undef or !is_string($directory) { 
        fail("'directory' is required and must be a string") 
    }
    
    if $timeout == undef or !is_numeric($timeout) { 
        fail("'timeout' is required and must be a number") 
    }
    
    if $mode != undef {
        if is_numeric($mode) {
            $arg_mode = "--mode $mode"
        } else {
            fail("'mode' must be numeric")
        }
    } else {
        $arg_mode = undef
    }
  
    if $parents and is_bool($parents) {
        $arg_parents = $parents ? {
            true => '--parents',
            default => undef,
        }
    }
  
    if $verbose and is_bool($verbose) {
        $arg_verbose = $verbose ? {
            true => '--verbose',
            default => undef,
        }
    }
  
    $args = join(delete_undef_values([ 
        $arg_mode, 
        $arg_parents,
        $arg_verbose,
    ]), " ")
  
    exec { "$::bi_coreutils::mkdir::params::exe_path $args $directory":
        timeout => $timeout,
        creates => $directory,
    } 
}